"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.open = open;
var _reactNative = require("react-native");
var _react = require("react");
// @ts-expect-error
const isTurboModuleEnabled = global.__turboModuleProxy != null;
const FileViewerTurbo = isTurboModuleEnabled ? require('./NativeFileViewerTurbo').default : _reactNative.NativeModules.FileViewerTurbo;
const eventEmitter =
// android relies on legacy emitter for backward compatibility
isTurboModuleEnabled && _reactNative.Platform.OS === 'ios' ? null : new _reactNative.NativeEventEmitter(FileViewerTurbo);
const dismissListener = /*#__PURE__*/(0, _react.createRef)();
async function open(path, options = {}) {
  const {
    onDismiss,
    ...nativeOptions
  } = options;
  try {
    await FileViewerTurbo.open(normalize(path), nativeOptions);
    dismissListener.current = addListener('onViewerDidDismiss', () => {
      dismissListener.current?.remove();
      onDismiss && onDismiss();
    });
  } catch (error) {
    throw error;
  }
}
const addListener = (event, listener) => {
  // android relies on legacy emitter for backward compatibility
  return !isTurboModuleEnabled || _reactNative.Platform.OS === 'android' ? eventEmitter?.addListener(event, listener) : FileViewerTurbo[event](listener);
};
function normalize(path) {
  const filePrefix = 'file://';
  if (path.startsWith(filePrefix)) {
    path = path.substring(filePrefix.length);
    try {
      path = decodeURI(path);
    } catch (e) {}
  }
  return path;
}
//# sourceMappingURL=index.js.map